package hsql_bsp3;

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;
import java.util.ArrayList;


public class FInsertUpdateMitarbeiter extends JDialog implements ActionListener{
    
  public boolean retcode=false;
  
  private ArrayList<ModelMitarbeiter> items = null;
  private ModelMitarbeiter mit;
  private ArrayList<ModelAbteilung> listeAbteilung=Mapping.selectModelAbteilung();
  
  private JLabel lCaption = new JLabel("Eingabe einer neuen Abteilung");
  private JLabel jLabel1 = new JLabel("Vorname");
  private JTextField tvorname = new JTextField();
  private JLabel jLabel2 = new JLabel("Nachname");
  private JTextField tnachname = new JTextField();
  private JLabel jLabel3 = new JLabel("Monatsgehalt");
  private JTextField tmonatsgehalt = new JTextField();

  private JLabel jLabel4 = new JLabel("Abteilung");
  private JComboBox<ModelAbteilung> cbAbteilung = new JComboBox<ModelAbteilung>();  
  
  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Abbrechen");
  
  private double monatsgehalt=0;
  
  public String getVorname() {
    return tvorname.getText().trim(); 
  }
  public String getNachname() {
    return tnachname.getText().trim(); 
  }
  public double getMonatsgehalt() {
    return monatsgehalt; 
  }
  public long getAIndex() {
      ModelAbteilung abt = (ModelAbteilung) cbAbteilung.getSelectedItem();
      return abt.getPIndex();
  }
  
  
  public FInsertUpdateMitarbeiter(Frame parent, ArrayList<ModelMitarbeiter> items, ModelMitarbeiter mit) {
    super(parent);
    setModal(true);
    setSize(400, 300);
    setTitle("Eingabe eines neuen Mitarbeiters");
    this.items = items;
    this.mit = mit;
    setGUI();
    if (mit!=null) {
        tvorname.setText(mit.getVorname());
        tnachname.setText(mit.getNachname());
        tmonatsgehalt.setText(mit.getGehaltMonat()+"");
        setTitle("Bearbeiten eines vorhanden Mitarbeiters");
        lCaption.setText( "Bearbeiten eines vorhanden Mitarbeiters" );
        for (int i=0; i<listeAbteilung.size(); i++) {
            ModelAbteilung abt = listeAbteilung.get(i);
            if (abt.getPIndex()==mit.getAIndex()) {
                cbAbteilung.setSelectedIndex(i);
                break;
            }
        }        
    }
    setVisible(true);
  }

  private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );

    jLabel1.setFont( new Font("Arial", Font.BOLD,14)  );
    tvorname.setFont( new Font("Arial", Font.BOLD,14)  );
    jLabel2.setFont( new Font("Arial", Font.BOLD,14)  );
    tnachname.setFont( new Font("Arial", Font.BOLD,14)  );
    jLabel3.setFont( new Font("Arial", Font.BOLD,14)  );
    tmonatsgehalt.setFont( new Font("Arial", Font.BOLD,14)  );
    jLabel4.setFont( new Font("Arial", Font.BOLD,14)  );
    cbAbteilung.setFont( new Font("Arial", Font.BOLD,14)  );

    bnOk.setFont( new Font("Arial", Font.BOLD,14)  );
    bnEsc.setFont( new Font("Arial", Font.BOLD,14)  );

    
    lCaption.setFont( new Font("Arial", Font.BOLD,18)  );
    lCaption.setForeground(Color.BLUE);
    
    this.getContentPane().add(lCaption,
         new GridBagConstraints(
             0, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(20,20,20,0), 0, 0));
    
    this.getContentPane().add(jLabel1,
         new GridBagConstraints(
             0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(10,20,0,0), 0, 0));

    this.getContentPane().add(tvorname,
        new GridBagConstraints(
               1, 1, 1, 1, 80.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.HORIZONTAL,
            new Insets(10,20,0,20), 0, 0));


    this.getContentPane().add(jLabel2,
         new GridBagConstraints(
             0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(20,20,0,0), 0, 0));

    this.getContentPane().add(tnachname,
        new GridBagConstraints(
             1, 2, 1, 1, 80.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(20,20,0,20), 0, 0));

    this.getContentPane().add(jLabel3,
         new GridBagConstraints(
             0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(20,20,0,0), 0, 0));

    this.getContentPane().add(tmonatsgehalt,
        new GridBagConstraints(
             1, 3, 1, 1, 80.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(20,20,0,20), 0, 0));
    
    
    
    this.getContentPane().add(jLabel4,
         new GridBagConstraints(
             0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(20,20,0,0), 0, 0));

    this.getContentPane().add(cbAbteilung,
        new GridBagConstraints(
             1, 4, 1, 1, 80.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(20,20,0,20), 0, 0));
    
    
    JPanel pn = new JPanel();
    pn.add(bnOk);
    pn.add(bnEsc);
    this.getContentPane().add(pn,
           new GridBagConstraints(
             0, 5, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(20,0,20,0), 0, 0));

    bnOk.addActionListener(this);
    bnEsc.addActionListener(this);
    
    
    for (ModelAbteilung abt : listeAbteilung) {
        cbAbteilung.addItem(abt);
    }
    cbAbteilung.setSelectedIndex(0);
    
  }  // setGUI
  
  

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource()==bnEsc) {
            this.dispose();
        }
        if (e.getSource()==bnOk) {
            bnOk_click();
        }
    } // actionPerformed
    
    private void bnOk_click() {
       String vorname = tvorname.getText().trim(); 
       String nachname = tnachname.getText().trim(); 
       String sgehalt = tmonatsgehalt.getText().trim(); 
       
       if (vorname.length()==0) {
           Basis.Message("Eingabe eines neuen Mitarbeiters", "Bitte geben Sie einen Vornamen ein");
           return;
       }
       if (nachname.length()==0) {
           Basis.Message("Eingabe eines neuen Mitarbeiters", "Bitte geben Sie einen Nachnamen ein");
           return;
       }
       if (!Basis.DVal(sgehalt)) {
           Basis.Message("Eingabe eines neuen Mitarbeiters", "Bitte geben Sie ein gültiges Gehalt");
           return;          
       }
       monatsgehalt = Basis.dblVal;
               
       retcode=true;
       this.dispose();
    } 

  
}
