package hsql_bsp3;

import java.util.ArrayList;

public class ModelAbteilung extends ModelBase{
   
        public static String SQL = "SELECT pindex, kurzbez, bez FROM Abteilung ORDER BY kurzbez;";
    
        private String kurzBez;
        private String bez;
        private long pindex;

        public void splitSQL(ArrayList tupels) {
           pindex = Integer.parseInt((String)tupels.get(0));
           kurzBez = (String) tupels.get(1);
           bez = (String) tupels.get(2);           
        }
        
        public static int getColumnCount() {
            return 3;
        }
        
        public static String getColumn(int col) {
            switch (col) {
                case 0: return "KurzBez"; 
                case 1: return "Bezeichnung"; 
                case 2: return "PIndex"; 
                default: return "Fehler in switch/case in Modul ModelAbteilung";
            }
        }
        public Object getValue(int col) {
            switch (col) {
                case 0: return kurzBez; 
                case 1: return bez; 
                case 2: return pindex; 
                default: return "Fehler in switch/case in Modul getValue";
            }
        }
        
        public void setValue(Object aValue, int col) {
            switch( col ) {
                case 0: setKurzBez( (String) aValue);
                        break;
                case 1: setBez( (String) aValue);
                        break;
                default: Basis.ErrorMsg("Fehler", "Fehler in setValue, column: "+col);
            }
        }
        
        
        public ModelAbteilung() {
            this(-1,"","");
        }

        public ModelAbteilung(long pindex, String kurzBez, String bez) {
            setPIndex(pindex);
            setKurzBez(kurzBez);
            setBez(bez);
        }
        
        public String getKurzBez() {
            return kurzBez; 
        }
        public String getKurzBezQuote() {
            return "'"+kurzBez+"'"; 
        }
        public void setKurzBez(String value) {
            if (value != kurzBez) {
                modify = true;
                kurzBez = value;
            }
        }

        public String getBez() {
            return bez; 
        }
        public String getBezQuote() {
            return "'"+bez+"'"; 
        }
        public void setBez(String value) {
            if (value != bez) {
                modify = true;
                bez = value;
            }
        }
       

        public long getPIndex() {
            return pindex; 
        }
        public void setPIndex(long pindex) {
            if (this.pindex != pindex) {
                modify = true;
                this.pindex = pindex;
            }
        }
       
         public int compareTo(Object obj) {
             return 0;
         }

        @Override
        public  String toString() {
            return kurzBez + "   " + bez;
        }    
    
}
